import 'package:test/test.dart';
import 'package:utilary/utilary.dart';

void main() {
  test("The sum of two vector is the sum of their components", () {
    expect(Vector(1, 0) + Vector(0, 1), equals(Vector(1, 1)));
  });

  test("A vector is greater than another if its magnitude is bigger", () {
    expect(Vector(3, 1) > Vector(1, 1), equals(true));
  });

  test("Multiply a vector by a constant scale its components", () {
    expect(Vector(1, 1) * 2, equals(Vector(2, 2)));
  });

  test("Rotate a vector 45degrees right", () {
    expect(Direction.north.rotate45Right(), equals(Direction.northEast));
  });

  test("Rotate a vector 90degrees left", () {
    expect(Direction.north.rotate90Left(), equals(Direction.west));
  });
  
  test("The direction a vector is pointing to discreting the result to the direction in Direction.all", () {
    expect(Vector(10, 1).nearestDirection, equals(Direction.east));
  });

  test("nearestDirection", () {
    expect(Vector(17, -16).nearestDirection, equals(Direction.southEast));
  });
}